/*

authorize - Use Mac OS X Authorization Services to request authorization for a
	specified right.

Copyright (c) 2002-2003 Occam's Razor. All rights reserved.

See the LICENSE file distributed with this code for restrictions on its use
and further distribution.
Original distribution available at <http://www.occam.com/tools/>.

$Id$

Compile with "cc -framework Security -o authorize authorize.c".

*/

#include <stdlib.h>
#include <Security/Authorization.h>

int main(int argc, char *argv[]) {
	char *commandName = argv[0];
	char *rightName;

	if (argc == 2)
		rightName = argv[1];
	else {
		fprintf(stderr, "usage: %s authorization_right_name\n", commandName);
		exit(EXIT_FAILURE);
	}

	OSStatus status;
	AuthorizationItem right = { rightName, 0, NULL, 0 };
	AuthorizationRights rightSet = { 1, &right };
	AuthorizationFlags flags =	kAuthorizationFlagDefaults |
					kAuthorizationFlagExtendRights |
					kAuthorizationFlagInteractionAllowed;

	status = AuthorizationCreate(&rightSet,
		kAuthorizationEmptyEnvironment, flags, NULL);

	if (status == errAuthorizationSuccess) {
		fprintf(stdout, "success\n");
		exit(EXIT_SUCCESS);
	} else {
		fprintf(stdout, "failure\n");
		exit(EXIT_FAILURE);
	}
}
